;********************************************
; FRI FOR FRANSK! SOUND-ROUTINES            *
; Marc Klemp (c) 2003, 2004, 2005           *
;********************************************

LoadVGMHeader:                                   ; DE = The start-address of the destination of the header.

   push hl
   push bc

   ld hl, FriVGM
   ld bc, $0018

   ldir

   pop bc
   pop hl

   ret

UpdateSound:

   push af
   push hl
   push de

   ld hl, ($C0C0)
   ld de, 735
   and $FF
   sbc hl, de
   jp c, DontWait

   ld ($C0C0), hl

   pop de
   pop hl
   pop af

   jp EndSoundInterrupt

DontWait:

   ld hl, $0000
   ld ($C0C0), hl

   pop de
   pop hl
   pop af

   inc hl
   ld a, (hl)

   cp $4F
   jp z, GGStereo
   cp $50
   jp z, PSGWrite
   cp $51
   jp z, YM2413Write
   cp $52
   jp z, YM2612Port0Write
   cp $53
   jp z, YM2612Port1Write
   cp $54
   jp z, YM2151Write
   cp $61
   jp z, WaitnSamples
   cp $62
   jp z, Wait735Samples
   cp $63
   jp z, Wait882Samples
   cp $66
   jp z, EndSoundData
   jp EndSoundInterrupt                          ; If none of the above, the instruction is illegal, and a jump to EndSoundInterrupt is being carried out.

GGStereo:

   inc hl
   ld a, (hl)
   out ($06), a
   jp UpdateSound

PSGWrite:

   inc hl
   ld a, (hl)
   out ($7F), a
   jp UpdateSound

YM2413Write:

   ; Ikke implementeret
   jp UpdateSound

YM2612Port0Write:

   ; Ikke implementeret
   jp UpdateSound

YM2612Port1Write:

   ; Ikke implementeret
   jp UpdateSound

YM2151Write:

   ; Ikke implementeret
   jp UpdateSound

WaitnSamples:

   push de

   inc hl
   ld e, (hl)
   inc hl
   ld d, (hl)

   push hl
   ld hl, ($C0C0)
   add hl, de
   ld ($C0C0), hl

   pop hl
   pop de

   jp UpdateSound

Wait735Samples:

   push de
   push hl

   ld de, 735
   ld hl, ($C0C0)
   add hl, de
   ld ($C0C0), hl

   pop hl
   pop de

   jp UpdateSound

Wait882Samples:

   push de
   push hl

   ld de, 882
   ld hl, ($C0C0)
   add hl, de
   ld ($C0C0), hl

   pop hl
   pop de

   jp UpdateSound

EndSoundData:

   push hl
   ld hl, $01
   ld ($C0D0), hl
   pop hl

   call StopSound

   jp EndInterrupt

EndSoundInterrupt:

   ei
   jp EndInterrupt

StopSound:

   ld a, %10010000
   out ($7F), a
   ld a, %10000000
   out ($7F), a
   ld a, %00000000
   out ($7F), a

   ret
